Fix unwind info in x86 memcmp-ssse3.
[glibc.git] / elf / ldd.bash.in
blob1bbefe2ff05ce4a1e85728c377d579229d0d344d
1 #! @BASH@
2 # Copyright (C) 1996-2008, 2009 Free Software Foundation, Inc.
3 # This file is part of the GNU C Library.
5 # The GNU C Library is free software; you can redistribute it and/or
6 # modify it under the terms of the GNU Lesser General Public
7 # License as published by the Free Software Foundation; either
8 # version 2.1 of the License, or (at your option) any later version.
10 # The GNU C Library is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
13 # Lesser General Public License for more details.
15 # You should have received a copy of the GNU Lesser General Public
16 # License along with the GNU C Library; if not, write to the Free
17 # Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
18 # 02111-1307 USA.
21 # This is the `ldd' command, which lists what shared libraries are
22 # used by given dynamically-linked executables. It works by invoking the
23 # run-time dynamic linker as a command and setting the environment
24 # variable LD_TRACE_LOADED_OBJECTS to a non-empty value.
26 # We should be able to find the translation right at the beginning.
27 TEXTDOMAIN=libc
28 TEXTDOMAINDIR=@TEXTDOMAINDIR@
30 RTLDLIST=@RTLD@
31 warn=
32 bind_now=
33 verbose=
35 while test $# -gt 0; do
36 case "$1" in
37 --vers | --versi | --versio | --version)
38 echo 'ldd (GNU libc) @VERSION@'
39 printf $"Copyright (C) %s Free Software Foundation, Inc.
40 This is free software; see the source for copying conditions. There is NO
41 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
42 " "2009"
43 printf $"Written by %s and %s.
44 " "Roland McGrath" "Ulrich Drepper"
45 exit 0
47 --h | --he | --hel | --help)
48 echo $"Usage: ldd [OPTION]... FILE...
49 --help print this help and exit
50 --version print version information and exit
51 -d, --data-relocs process data relocations
52 -r, --function-relocs process data and function relocations
53 -u, --unused print unused direct dependencies
54 -v, --verbose print all information
56 echo $"For bug reporting instructions, please see:
57 <http://www.gnu.org/software/libc/bugs.html>.
59 exit 0
61 -d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \
62 --data-rel | --data-relo | --data-reloc | --data-relocs)
63 warn=yes
64 shift
66 -r | --f | --fu | --fun | --func | --funct | --functi | --functio | \
67 --function | --function- | --function-r | --function-re | --function-rel | \
68 --function-relo | --function-reloc | --function-relocs)
69 warn=yes
70 bind_now=yes
71 shift
73 -v | --verb | --verbo | --verbos | --verbose)
74 verbose=yes
75 shift
77 -u | --u | --un | --unu | --unus | --unuse | --unused)
78 unused=yes
79 shift
81 --v | --ve | --ver)
82 echo >&2 $"ldd: option \`$1' is ambiguous"
83 exit 1
85 --) # Stop option processing.
86 shift; break
88 -*)
89 echo >&2 'ldd:' $"unrecognized option" "\`$1'"
90 echo >&2 $"Try \`ldd --help' for more information."
91 exit 1
94 break
96 esac
97 done
99 nonelf ()
101 # Maybe extra code for non-ELF binaries.
102 return 1;
105 add_env="LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now"
106 add_env="$add_env LD_VERBOSE=$verbose"
107 if test "$unused" = yes; then
108 add_env="$add_env LD_DEBUG=\"$LD_DEBUG${LD_DEBUG:+,}unused\""
111 # The following use of cat is needed to make ldd work in SELinux
112 # environments where the executed program might not have permissions
113 # to write to the console/tty. But only bash 3.x supports the pipefail
114 # option, and we don't bother to handle the case for older bash versions.
115 if set -o pipefail 2> /dev/null; then
116 try_trace() {
117 eval $add_env '"$@"' | cat
119 else
120 try_trace() {
121 eval $add_env '"$@"'
125 case $# in
127 echo >&2 'ldd:' $"missing file arguments"
128 echo >&2 $"Try \`ldd --help' for more information."
129 exit 1
132 single_file=t
135 single_file=f
137 esac
139 result=0
140 for file do
141 # We don't list the file name when there is only one.
142 test $single_file = t || echo "${file}:"
143 case $file in
144 */*) :
146 *) file=./$file
148 esac
149 if test ! -e "$file"; then
150 echo "ldd: ${file}:" $"No such file or directory" >&2
151 result=1
152 elif test ! -f "$file"; then
153 echo "ldd: ${file}:" $"not regular file" >&2
154 result=1
155 elif test -r "$file"; then
156 test -x "$file" || echo 'ldd:' $"\
157 warning: you do not have execution permission for" "\`$file'" >&2
158 RTLD=
159 ret=1
160 for rtld in ${RTLDLIST}; do
161 if test -x $rtld; then
162 verify_out=`${rtld} --verify "$file"`
163 ret=$?
164 case $ret in
165 [02]) RTLD=${rtld}; break;;
166 esac
168 done
169 case $ret in
171 # If the program exits with exit code 5, it means the process has been
172 # invoked with __libc_enable_secure. Fall back to running it through
173 # the dynamic linker.
174 try_trace "$file"
175 rc=$?
176 if [ $rc = 5 ]; then
177 try_trace "$RTLD" "$file"
178 rc=$?
180 [ $rc = 0 ] || result=1
183 # This can be a non-ELF binary or no binary at all.
184 nonelf "$file" || {
185 echo $" not a dynamic executable"
186 result=1
190 try_trace "$RTLD" "$file" || result=1
193 echo 'ldd:' ${RTLD} $"exited with unknown exit code" "($ret)" >&2
194 exit 1
196 esac
197 else
198 echo 'ldd:' $"error: you do not have read permission for" "\`$file'" >&2
199 result=1
201 done
203 exit $result
204 # Local Variables:
205 # mode:ksh
206 # End: